#include <cmath>
#include <iostream>

using namespace std;

class complexNumber
{
private:
	double y;

public:	
	double x;
	complexNumber(double cx=0, double cy=0);
	void add(const complexNumber & c);
	void multiply(const complexNumber & c);
	void divide(const complexNumber & c);
	double norm() const;
	void print();
};




int main()
{
	complexNumber z(2,3);
	z.print();
	complexNumber w;
	w.print();
	w=z;
	w.print();
	w.x=1.0;
	w.print();
	z.add(w);
	z.print();
	z.multiply(w);
	z.print();
	cout<<w.norm()<<endl;
	return 0;
}


complexNumber::complexNumber(double cx, double cy)
{
	x = cx;
	y = cy;
}

void complexNumber::add(const complexNumber & c)
{
	x+=c.x;
	y+=c.y;
}

void complexNumber::multiply(const complexNumber & c)
{
	double	tempx= x;
	x=x*c.x-y*c.y;
	y=tempx*c.y+c.x*y;
}
void complexNumber::divide(const complexNumber & c)
{
	double tempx= x;
	x=(x*c.x+y*c.y)/(c.x*c.y+c.y*c.y);
	y=c.x*y-tempx*c.y;
}
double complexNumber::norm() const
{
	return sqrt(x*x+y*y);
}

void complexNumber::print()
{
	cout<<x<<" + "<<y<<"i"<<endl;
}

