#include <iostream>
using namespace std;


class myDynamicArray
{

public:
	int * A;
	int size;

	myDynamicArray(int sizeValue);
	myDynamicArray();
	myDynamicArray(const myDynamicArray & other);

	~myDynamicArray();
	int search(int query) const;
	void print() const;
	bool isSorted() const;
	void insertionSort();
	void copy(const myDynamicArray & copied);
	void concatinate(myDynamicArray & B);
};

int main()
{
	int testedsize=10;
	myDynamicArray testedarray(testedsize), myArray(1);
	for(int i=0;i<testedarray.size;i++) {
		testedarray.A[i]=(rand()%100); // rand() generates a random number between 0 and 32767 (See [Malik, page 1480])
	}
	cout<<"Array1: ";testedarray.print();
	myArray.copy(testedarray);
	cout<<"Array2: ";myArray.print();
	cout<<"Array2 is ";
	if(myArray.isSorted()) cout<<"sorted."<<endl; 
	else {
		cout<<"unsorted."<<endl<<"Array 2 is being sorted...";
		myArray.insertionSort();
		myArray.print();
	}
	cout<<"Array1+Array2: ";
	myArray.concatinate(testedarray);
	myArray.print();
	cout<<"Search Array1+Array2 for: ";
	int num, result;
	cin>>num;
	result=myArray.search(num);
	if(result!=-1)
		cout<<"Number has been found in index "<<result;
	else
		cout<<"Number not found!";
	cout<<endl<<endl;
	return 0;
}




myDynamicArray::myDynamicArray()
{
	A= new int[999];
	size=999;
	for(int i=0;i<size;i++)
		A[i]=0;
}

myDynamicArray::myDynamicArray(int sizeValue)
{
	size=sizeValue;
	A=new int[size];
	for(int i=0;i<size;i++)
		A[i]=0;
}

myDynamicArray::myDynamicArray(const myDynamicArray & other)
{
    copy(other);
}

myDynamicArray::~myDynamicArray()
{
	delete [] A;
}

int myDynamicArray::search(int query) const
{
	for(int i=0; i<size; i++)
	if(A[i]==query) return i;
	return -1;
}

void myDynamicArray::print() const
{
	for(int i=0;i<size;i++)
		cout<<A[i]<<" ";
	cout<<endl;
}

bool myDynamicArray::isSorted() const
{
	bool sorted=true;
	for(int i=1;i<size;i++)
		if(A[i-1]>A[i]) sorted=false;
	return sorted;
}

void myDynamicArray::insertionSort()
{
	int temp;
	for(int j=1;j<size;j++) {
		temp=A[j];
		for(int i=j-1; (A[i]>temp) && (i>-1);i--)
			A[i+1]=A[i];
			A[i+1]=temp;
	}
}

void myDynamicArray::copy(const myDynamicArray & copied)
{
	delete [] A;
	A = new int[copied.size];
	size=copied.size;
	for(int i=0; i<size; i++)
		 A[i]=copied.A[i];
}

void myDynamicArray::concatinate(myDynamicArray & B)
{
	int * final;
	final = new int[size+B.size];
	for(int i=0;i<size;i++)
		final[i]=A[i];
	for(i=size; i<(size+B.size); i++)
		final[i]=B.A[i-size];
	delete [] A;
	A = final;
	size=size + B.size;
}



